include acdef.inc
.model tiny
.code
.386
        org 100h
Start:	jmp RealStart

	include dosmacro.inc ; DOS Service pack macros
	include ac.inc

RealStart:
        @cominit
if demo
        @lnprint '~M !!! DEMO VERSION !!! FOR INTERNAL USE INSIDE SMF ONLY !!! DON''T DISTRIBUTE !!!'
endif
        @lnprint _version

        mov bx,80h
        mov al,cs:[bx]
        test al,al
        jnz loadfile
        jmp help

loadfile:
loop1:  inc bx
        cmp byte ptr cs:[bx], 20h
        jna loop1
        mov [fname],bx
loop2:  inc bx
        cmp byte ptr cs:[bx], 20h
        ja loop2
        mov byte ptr cs:[bx], 0

        xor al,al
        mov dx,cs:[fname]
        @doscall Dopen
        jnc openok
FErr:   @error 'Can''t open file'
        jmp exit
openok:
        mov cs:[handle],ax
        mov bx,1000h
        @doscall Dmemalloc
        jnc mem1ok
memerror:
        @error 'Not enough of DOS memory'
        jmp exit
mem1ok: mov cs:[inpsel],ax
        mov ds,ax
        xor dx,dx
        mov cx,0ffffh
        mov bx,cs:[handle]
        @doscall Dread
        inc ax
        jz LongEr
        dec ax
        jz FErr
        jmp Longok
LongEr:	@error 'File too long!'
        jmp Release
Longok:
        mov cs:[filelen],ax
        push bx

        call __lnp
	db '~','A'+titlec,'  Reading  : ~','A'+infoc,0
	mov si,cs:[fname]
        push offset endmes1
        jmp mesloop
endmes1:
	pop bx
        @doscall Dclose

; ============= TEST FOR CRYPTORS AND PACKERS ================
        call txt2com
        call ucfpack
        call ucfcrypt
        call c00l
        call nide
        call cr1
        call scrypt1
        call execom
        call cry2
        call execom2
	call et21cm
	call et21ec
	call et21cc
        call et11ec
	call CrStop
	call et11e2c
	call comtxt3
	call synop
	call CNT
	call comlock
	call execom3
	call wiz
	call Skull
	call Kisl
	call SQRWV
        call Unk2
	call Dism2
	call HS117c
	call Digc
	call HS117e
	call Razcc
	call Razcp

        @error 'Cryptors not found'

Release:
        mov ax,cs:[inpsel]
        mov es,ax
        @doscall Dmemfree

exit:
        @doscall Dexit
help:
        call __lnp
        db '~','A'+helpc,'Usage:  ac <progname.com> | <progname.exe> (??)',0
;        @error 'No input filename'
        jmp exit



; ============== SYSTEM PROCEDURES ==============

;   calculate checksum in loaded program
;   in: bx=offset
;       cx=length
;   out ax=sum
;       ds=inpsel

chksum1:push ds
	pop es
chksum:	push bx
        mov ax,cs:[inpsel]
        mov ds,ax
        mov es,ax
        xor ax,ax
sum1:   movzx dx,byte ptr ds:[bx]
        add ax,dx
        inc bx
        loop sum1
        pop bx
        ret

; ============== SAVE RESULT ==============
;   in: cx=size (from savelen length=old length)
;       ds=seg (from savseg ds=inpsel)
;       bx=start (from save0 start=0 and ds=inpsel)

savelen:mov cx,cs:[filelen]
save0:  xor bx,bx
savseg: mov ax,cs:[inpsel]
        mov ds,ax
save:   push ds cx bx
        mov ax,cs
        mov ds,ax
        mov di,ds:[fname]
        push di
slp1:   inc di
        cmp byte ptr ds:[di], '.'
        jz sfnd
        cmp byte ptr ds:[di], ' '
        ja slp1
sfnd:   mov dword ptr ds:[di], '.' + 'a'*100h + 'c'*10000h
        xor cx,cx
        pop dx
        @doscall Dcreate
        jnc scok
sferr:  @lnprint 'Can''t create output file'
        jmp Release
scok:   mov bx,ax
        pop dx cx ds
        @doscall Dwrite
        jc sferr
        @doscall Dclose

        call __lnp
	db '~','A'+titlec,'  Saving   : ~','A'+infoc,0
	mov si,cs:[fname]
        push offset Release
        call mesloop
        call __lnp
	db '~HSuccess!',0
        ret

; ============ Make exe header ==========
; in:	cx=no. of relocs
;	ds:si=start of relocs
; 	es:0 =start of creating exe
; out:
;	di=address of new code
;	if ds:0=old exe header, then ds:si=start of old code
MkHdr:  push cx
	mov ax,'M'+256*'Z'
	mov es:[0],ax
	mov es:[6],cx
	mov ax,0ffffh
        mov es:[0ch],ax
        xor ax,ax
        mov es:[12h],ax
        mov es:[1ah],ax
        mov ax,1ch
        mov es:[18h],ax
        mov di,1ch
        add cx,cx
        rep movsw
	dec di
	shr di,4
	inc di
        mov es:[8],di
        shl di,4
	mov si,ds:[8]
        shl si,4
        pop cx
	ret

; ===== Set exe length and save file ====
; in:
;	es:di=end of exe code
Setlen: mov ax,di
        shr ax,4
        inc ax
        mov es:[0ah],ax
Setlen1:mov cx,di
	mov ax,di
        and ax,1ffh
        mov es:[2],ax
        dec di
        shr di,9
        inc di
	mov es:[4],di
	push es
        pop ds
	xor bx,bx
	jmp save

; ============== VARIABLES ==============
inpsel  dw ?    ; input file buffer segment
fname   dw 81h  ; pointer to fiename
filelen dw ?    ; legth of input file
handle  dw ?    ; current file handle
ovrseg  dw ?    ; possible file overlay segment
ovrsize dw ?    ; possible overlay size
oldss   dw ?    ; save for ss
oldsp   dw ?    ; save for sp
newsize dw ?    ; unpacked program size
codest	dw ?	; start of exe code
execip	dw 100h	; variable for call far
execcs	dw ?	; variable for call far

cdstart dw 100h,? ; code start

; ============== COM 2 TXT by Dandler ==============
txt2com:
        mov bx,18ch
        mov cx,300h-28ch
        call chksum
        cmp ax,1db2h
        jnz retptr
        @detect c1
        @class c1t
        mov si,303h-100h
        xor di,di
tmainlp:lodsb
        cmp al,'P'
        jz tx1
        sub al,40h
        jc tmainlp
        shl al,4
        mov bl,al
        lodsb
        sub al,40h
        add al,bl
        stosb
        jmp tmainlp
tx1:    sub di,29h
        mov cx,di
        mov bx,29h
        jmp savseg
retptr: ret

; ============== UCF PACKER ==============
ucfpack:
        xor bx,bx
        mov cx,0f0h
        call chksum
        cmp ax,6c6ah
        jnz retptr
        @detect c2
        @class c2t
        @lnprint '~Boverlay start      :'
        mov ax,ds:[200h]
        xchg al,ah
        add ax,207h ; AX=overlay start
        push ax
        call printax
        mov bx,1000h
        @doscall Dmemalloc
        jc memerror
        mov es,ax
        mov cs:[ovrseg],ax
        pop si
        mov cx,cs:[filelen]
        sub cx,si
        mov cs:[ovrsize],cx
        push cx
        xor di,di
        rep movsb
        @lnprint 'Overlay size       :'
        pop ax
        call printax
        mov byte ptr ds:[0f0h], 0cbh ; retf
        mov ax,ds
        sub ax,10h
        mov ss,ax
        mov es,ax
        mov ds,ax
        mov cs:[oldss],ss
        mov cs:[oldsp],sp
        mov sp,0ffech
        mov word ptr cs:[cdstart][2], ax
        call dword ptr cs:[cdstart]
        mov ss,cs:[oldss]
        mov sp,cs:[oldsp]
        sub di,100h
        mov cs:[newsize],di
        mov ax,cs:[ovrseg]
        mov ds,ax
        xor si,si
        mov ax,cs:[inpsel]
        mov es,ax
        mov cx,cs:[ovrsize]
        push di
        rep movsb
        @lnprint 'New overlay address:'
        pop ax
        call printax
        push di
        mov ax,cs:[ovrseg]
        mov es,ax
        @doscall Dmemfree
        pop cx
        jmp save0

; ============== UCF CRYPTOR ==============
ucfcrypt:
        mov bx,8abh
        mov cx,2fh
        call chksum
        cmp ax,15e0h
        jnz retptr
        @detect c3
        @class c3t

        mov bx,8dch
        mov dx,ds:[6]
        sub dx,100h
xorloop:mov ax,ds:[bx]
        xor ax,0f2h
        mov ds:[bx],ax
        inc bx
        cmp bx,dx
        jne xorloop
        mov byte ptr ds:[8d6h],0
                        ;mirroring:
        mov si,0a16h
        mov cx,dx
        mov di,cx
        dec di
        sub cx,0a18h
        shr cx,1
        cld
mirrloop:
        lodsb
        xchg al,es:[di]
        mov [si-1],al
        dec di
        loop mirrloop
        mov ax,16ebh
        mov ds:[9feh],ax
        jmp savelen

; ============== C00l Protection ==============
c00l:   mov bx,1fh
        mov cx,14h
        call chksum
        cmp ax,0cf4h
        jnz retptr
        @detect c4
        @class c4t
        mov bx,ds:[12h]
        sub bx,100h
        mov cx,ds:[1bh]
        xor dl,dl
c00lp:  xor byte ptr ds:[bx],dl
        inc bx
        inc dl
        loop c00lp
        mov eax,90909090h
        mov word ptr ds:[26h], ax
        mov dword ptr ds:[0], eax
        jmp savelen

; ============== COM 2 TXT by Nide ==============
nide:   xor bx,bx
        mov cx,0c7h
        call chksum
        cmp ax,3a79h
        jnz retptr
        @detect c5
        @class c5t
        xor cx,cx
        xor si,si
        mov di,0c9h
ndlp1:  ror ax,cl
        mov ah,al
ndget:  mov al,ds:[di]
        inc di
        cmp al,3ah
        jnz ndn
        jmp savesi
ndn:    add al,al
        add al,al
        jb ndbit
        neg al
        js ndget
        sub al,30h
        jbe ndbit
        add al,68h
ndbit:  shl ax,cl
        jcxz ndput
        mov ds:[si],ah
        inc si
ndput:  add cx,2
        and cl,0f7h
        jmp ndlp1

; ============== Crypt.114 ==============
cr1:    call chksum
        mov si,ds:[1]
        add si,3
        cmp byte ptr ds:[si],0bbh
        jnz retptr
        cmp word ptr ds:[si+6],0f31h
        jnz retptr
        push si
        @detect c6
        @class c6t
        pop si
        mov di,si
        mov bx,ds:[si+1]
        mov cx,ds:[si+4]
        sub bx,100h
cr11:   xor ds:[bx],cx
        dec bx
        loop cr11
        mov cx,0f000h
cr12:   inc si
        cmp word ptr [si],7c7h
        loopnz cr12
        test cx,cx
        jz error
        mov ax,ds:[si+2]
        mov ds:[0],ax
        mov al,ds:[si+7]
        mov ds:[2],al
        jmp savedi

Error:  @error 'Crypt CRC Error!'
        ret

; ============== Crypt.114 ==============
scrypt1:mov bx,3eh
        mov cx,9
        call chksum
        cmp ax,3c9h
        jnz retptr
        mov bx,28h
        mov cx,10h
        call chksum
        cmp ax,383h
        jnz retptr
        @detect c7
        @class c7t
        mov si,54h
        mov di,si
        mov cx,ds:[47h]
sclp1:  lodsw
        xor ax,word ptr ds:[4fh]
        stosw
        loop sclp1
        mov cx,ds:[0e6h]
        mov si,127h
        mov di,si
sclp2:  lodsw
        xor ax,ds:[0eeh]
        mov bx,cx
        add bx,1ch
        neg bx
        rol bx,3
        xor bx,ds:[0ffh]
        xor ax,bx
        stosw
        loop sclp2
        mov si,487h
        xor di,di
        mov cx,ds:[3ah]
sclp3:  lodsb
        xor al,60h
        xor ax,di
        stosb
        loop sclp3
        jmp savedi

; ============== EXE 2 COM ==============
execom: mov cx,0b0h
        xor bx,bx
        call chksum
        cmp ax,4c97h
        jnz retptr
        @detect c8
        @class c8t
        mov cx,cs:[filelen]
        mov bx,0b0h
        sub cx,bx
        jmp savseg


; ============== Crypt.89 ==============
cry2:   call chksum
        mov bx,ds:[1]
        add bx,3
        push bx
        add bx,0dh
        mov cx,0fh
        call chksum
        pop bx
        cmp ax,74bh
        jnz retptr
        push bx

        @detect c9
        @class c9t
        pop bx
        mov ax,ds:[bx+1dh]
        mov ds:[0],ax
        mov al,ds:[bx+22h]
        mov ds:[2],al
        mov ax,ds:[bx+2]
        mov dx,ds:[bx+5]
        mov cx,ds:[bx+8]
        push bx
        mov si,3
c2lp1:  xor ds:[si],al
        add al,dl
        xchg al,ah
        xchg dl,dh
        inc si
        loop c2lp1
        pop cx
        jmp save0

; ============== Exe 2 com from exetools 2.1 ==============
execom2:call chksum
        mov bx,ds:[1]
        add bx,3
        push bx
        add bx,19h
        mov cx,18h
        call chksum
        pop bx
        cmp ax,0beah
        jnz retptr
        push bx
        @detect c10
        @class c10t
        mov bx,1000h
        @doscall Dmemalloc
        jc memerror
        mov es,ax
        pop bx
        mov ax,ds:[bx+46h]
        sub ax,10h
        mov es:[16h],ax
        mov ax,ds:[bx+44h]
        mov es:[14h],ax
        mov ax,1ch
        mov es:[18h],ax
        mov ax,ds:[bx+31h]
        sub ax,10h
        mov es:[0eh],ax
        mov ax,ds:[bx+38h]
        mov es:[10h],ax

        mov cx,ds:[bx+14h]
        call MkHdr
        jcxz etce2
        lea si,bx[4ch]
        push di
        mov di,1ch
etce1:	lodsw
	sub ax,100h
        stosw
        xor ax,ax
        stosw
	loop etce1
        pop di
etce2:	mov si,3
        lea cx,bx[-3]
	rep movsb
	jmp Setlen

; ============== .Com file comment from exetools 2.1 ==============
et21cm:	mov bx,12h
	mov cx,bx
        call chksum
        cmp ax,8bch
        jnz retptr
        cmp byte ptr ds:[0],68h
        jnz retptr
        @detect c11
        @class c11t
        mov bx,ds:[7]
        sub bx,100h
        mov cx,cs:[filelen]
        sub cx,bx
        jmp savseg

; ============== Exe cryptor from exetools 2.1 ==============
et21ec:	call chksum
        mov bx,ds:[16h]
        add bx,ds:[8]
        shl bx,4
        add bx,ds:[14h]
        push bx
        add bx,17h
        mov cx,3bh
        call chksum
        pop bx
        cmp ax,2032h
        jnz retptr
        push bx
        @detect c12
        @class c12t
        mov bx,1000h
        @doscall Dmemalloc
        jc memerror
        mov es,ax
        pop bx
        mov ax,ds:[bx+0b3h]
        mov es:[14h],ax
        mov ax,ds:[bx+0b5h]
        mov es:[16h],ax
	mov ax,ds:[bx+0bbh]
        mov es:[0eh],ax
        mov ax,ds:[bx+0bdh]
        mov es:[10h],ax
	mov cx,ds:[bx+53h]

        lea si,bx[123h]
        push si cx
        jcxz et21ec0
        add cx,cx
        add cx,cx
        mov ah,1
et21ec1:mov al,ds:[si]
	xor al,ah
        rol ah,3
        add ah,cl
        mov ds:[si],al
        inc si
        loop et21ec1
et21ec0:pop cx si
	call MkHdr
        mov cx,ds:[bx+12h]
        mov ah,1
et21ec2:lodsb
	xor al,ah
        rol ah,3
        add ah,cl
        stosb
        loop et21ec2
	jmp Setlen

; ============== Com cryptor from exetools 2.1 ==============
et21cc:	mov bx,9
	mov cx,23h
        call chksum
        cmp ax,126ah
        jnz retptr
        cmp byte ptr ds:[0],68h
        jnz retptr
        @detect c13
        @class c13t
        push ds
        pop es
        mov si,ds:[4]
        sub si,100h
        xor di,di
        mov cx,ds:[7]
        push cx
        mov ah,1
et21cc1:lodsb
	xor al,ah
        rol ah,3
        add ah,cl
        stosb
        loop et21cc1
	pop cx
        jmp save0

; ============== Exe cryptor from exetools  ==============
et11ec:	call chksum
        mov bx,ds:[16h]
        add bx,ds:[8]
        shl bx,4
        add bx,ds:[14h]
        mov cx,19h
        call chksum
        cmp ax,0b7ch
        jnz retptr
        push bx
        @detect c14
        @class c14t
        mov bx,1000h
        @doscall Dmemalloc
        jc memerror
        mov es,ax
        pop bx
        mov ax,ds:[bx+0a8h]
        mov es:[14h],ax
        mov ax,ds:[bx+0aah]
        mov es:[16h],ax
	mov ax,ds:[0eh]
        mov es:[0eh],ax
        mov ax,ds:[10h]
        mov es:[10h],ax
	mov cx,ds:[bx+5eh]
        lea si,bx[0b4h]
	push si cx
	jcxz et11ec0
        add cx,cx
        add cx,cx
        mov ah,1
et11ec1:mov al,ds:[si]
	xor al,ah
        rol ah,3
        add ah,cl
        mov ds:[si],al
        inc si
	loop et11ec1
et11ec0:pop cx si
	call MkHdr
        mov cx,ds:[bx+1ch]
        mov ah,1
et11ec2:lodsb
	xor al,ah
        rol ah,3
        add ah,cl
        stosb
        loop et11ec2
	jmp setlen

; ============ CrackStop 1.01 by Stefan Esser =============
CrStop:	call chksum
        cmp word ptr ds:[14h],5
        jnz retptr
        mov bx,ds:[16h]
        add bx,ds:[8]
        shl bx,4
        add bx,ds:[14h]
        mov cx,27h
        call chksum1
        cmp ax,14d4h
        jnz retptr
        push bx
        @detect c15
        @class c15t
        pop bx
        sub bx,5
        xor cx,cx
        mov ax,ds:[bx+0ddeh]
        xor ax,0d56h
        xor ax,4228h
        mov ds:[0eh],ax
        mov ax,ds:[bx+0dech]
        xor ax,0fffeh
        xor ax,1233h
        mov ds:[10h],ax
        mov ax,ds:[bx+0e17h]
        xor ax,383bh
        mov ds:[14h],ax
        mov ax,ds:[bx+0e19h]
        xor ax,0d56h
        xor ax,9ff3h
        mov ds:[16h],ax

	xor al,al
        mov cx,ds:[bx+0aa8h]
        xor cx,0d7f5h
        xor cx,3516h
        mov di,ds:[8]
        shl di,4
cs1:	mov dl,ds:[bx+0ab5h]
        xor dl,0d5h
        xor dl,4bh
        add al,dl
        mov dl,ds:[bx+0ab7h]
        xor dl,2ah
        xor dl,0bah
        xor al,dl
        rol al,1
	mov dl,ds:[bx+0abch]
        xor dl,0d3h
        xor dl,0a7h
        add al,dl
        xor ds:[di],al
        inc di
        loop cs1
	jmp Setlen

; =============== Exe 2 com from exetools ================
et11e2c:call chksum
        mov bx,ds:[1]
        add bx,3
        push bx
        add bx,19h
        mov cx,18h
        call chksum
        pop bx
        cmp ax,0be6h
        jnz retptr
        push bx
        @detect c16
        @class c16t
        mov bx,1000h
        @doscall Dmemalloc
        jc memerror
        mov es,ax
        pop bx
        mov ax,ds:[bx+44h]
        mov es:[16h],ax
        mov ax,ds:[bx+42h]
        sub ax,100h
        mov es:[14h],ax
        mov ax,1ch
        mov es:[18h],ax
        mov ax,ds:[bx+31h]
        sub ax,10h
        mov es:[0eh],ax
        mov ax,ds:[bx+38h]
        mov es:[10h],ax

        mov cx,ds:[bx+14h]
        call MkHdr
        jcxz etce2x
        lea si,bx[4eh]
        push di
        mov di,1ch
etce1x:	lodsw
	sub ax,100h
        stosw
        xor ax,ax
        stosw
	loop etce1x
        pop di
etce2x:	mov si,3
        lea cx,bx[-3]
	rep movsb
	jmp Setlen
; =============== COM 2 TXT (NETRUN 3.10) ================
comtxt3:mov bx,146h
	mov cx,28h
        call chksum1
        cmp ax,0b89h
        jnz retptr
        @detect c17
        @class c17t
        mov bx,cs:[filelen]
        mov dword ptr ds:[bx],'"'*1000000h+'"'*10000h+'"'*100h+'"'
	mov si,148h
        xor di,di
        mov cx,8
ct31:	lodsb
	sub al,22h
        jb ct31
        jz ct31ok
	dec ax
        mov ah,5bh
        mul ah
        xchg ax,dx
        xor ax,ax
ct32:	lodsb
	sub al,23h
        jb ct32
        add ax,dx
        stosb
        xor al,al
        shr ax,cl
        or ch,al
        sub cl,5
        jg ct31
        mov ds:[di],ch
        inc di
        mov ch,ah
        add cl,8
        cmp di,0fe80h
        jb ct31
ct31ok:	jmp savedi

; =============== Synopsis' .com-packer ==================
Synop:  mov ax,ds
	mov es,ax
        mov cs:[syseg1],ax

	xor bx,bx
	mov cx,58h
	call chksum
        cmp ax,2b15h
        jnz retptr

	mov si,0fe00h
	mov di,0ff00h
        mov cx,0fe01h
        std
        rep movsb
        cld
        @detect c18
        @class c18t
        mov bp,103h
        mov di,0ff22h
        mov byte ptr ds:[157h],0cbh
        db 9ah	; call far ds:130
        dw 130h
syseg1	dw ?
	mov byte ptr ds:[130h],0eah	; ds:130	jmp AC:SynHook
        mov word ptr ds:[131h],offset SynHook
        mov ax,cs
        mov word ptr ds:[133h],ax
	push ds
        push 10ah
        retf
SynHook:mov byte ptr ds:[0ff08h],90h
	mov byte ptr ds:[0feech],0cbh
        pop si
        push cs
        push offset SynH2
        push ds
	push 0feffh
        retf
SynH2:	mov bx,100h
	lea cx,di[-100h]
        jmp savseg

; =============== CNT-Crypt by C0NTRiVER =================
CNT:	mov bx,ds:[5]
	add bx,7h
        mov cx,19h
        call chksum1
        cmp ax,8d9h
        jnz retptr
        push bx
        @detect c19
        @class c19t
        pop bx
        lea cx,bx[-7h]
        push cx
        mov si,7
        xor di,di
CNT1:	lodsb
	xor ax,cx
        stosb
        loop CNT1
        pop cx
        jmp save0

; =============== COMLOCK 0.10 =================
comlock:mov bx,ds:[1]
	add bx,3
        push bx
        add bx,1ah
        mov cx,36h
        call chksum1
        pop bx
	cmp ax,1786h
        jnz retptr
        push bx
        @detect c20
        @class c20t
        pop bx
        mov cx,ds:[1]
        mov al,ds:[bx+4]
        mov ds:[0],al
        mov ax,ds:[bx+5]
        mov ds:[1],ax
        mov al,ds:[bx+3]
        mov si,3
cmlk1:	xor ds:[si],al
	inc si
        inc al
        loop cmlk1
savesi:	mov cx,si
        jmp save0
	
; =============== EXE 2 COM N.2 =================
execom3:mov bx,ds:[1]
	add bx,3
        push bx
        add bx,2eh
        mov cx,0ch
        call chksum1
        pop bx
        cmp ax,66bh
        jnz retptr
        push bx
        @detect c21
        @class c21t
        mov bx,1000h
        @doscall Dmemalloc
        jc memerror
        mov es,ax
        pop bx
        mov cx,ds:[bx+3ah]
        sub cx,2
	call MkHdr
        push di
        mov di,1ch
        lea si,bx[-2]
        sub si,cx
        sub si,cx
        push si
        jcxz ec2l1
ec2l0:	lodsw
	dec ah
	stosw
        xor ax,ax
        stosw
        loop ec2l0
ec2l1:	pop cx di
	mov ax,ds:[bx-2dh]
        mov ds:[0],ax
        mov al,ds:[bx-2bh]
        mov ds:[2],al
        xor si,si
	rep movsb
        mov ax,ds:[bx+4]
        mov es:[0ah],ax
        mov ax,ds:[bx+4bh]
        mov es:[14h],ax
        mov ax,ds:[bx+4dh]
        mov es:[16h],ax
        mov ax,ds:[bx-2]
        mov es:[0eh],ax
        mov ax,ds:[bx+47h]
	mov es:[10h],ax
        jmp setlen1

; =============== Wiz 1.00a =================
Wiz:	mov bx,ds:[1]
	add bx,3
        push bx
        add bx,54h
        mov cx,9
        call chksum1
	pop bx
        cmp ax,441h
        jnz retptr
        push bx
        @detect c22
        @class c22t
        pop bx
        mov ax,ds:[bx+41h]
        mov ds:[0],ax
        mov al,ds:[bx+46h]
        mov ds:[2],al
        mov cx,[bx+4fh]
        mov dl,55h
        mov si,3h
        mov di,ds:[bx+63h]
        sub di,100h
wlp1:	mov ax,ds:[di]
	inc di
        add dl,al
        xor ds:[si],dl
        inc si
        mov ax,ds:[bx+05eh]
        dec ah
	cmp di,ax
	jnz wNO
        mov di,ds:[bx+63h]
        sub di,100h
wNO:	dec cx
	jnz wlp1
	jmp savesi

; =============== Crypts by Skullcoder 95-97 ===============
Skull:	mov bx,ds:[1]
	add bx,3
        cmp word ptr ds:[bx],0c760h
        jnz retptr
        lea di,bx[10h]
	mov al,43h
        mov cx,50h
	repnz scasb
        or cx,cx
        jz retptr
	cmp dword ptr ds:[di],0e20fe380h
        jnz retptr
        cmp word ptr ds:[di+5],0ff61h
        jnz retptr
        push di bx
        @detect c23
        @class c23t
        pop bx di
	mov byte ptr ds:[di+6],0cbh	;retf
        mov ax,ds
        sub ax,10h
        mov ds,ax
	mov cs:[execcs],ax
        mov si,100h
        push bx
        xor bx,bx
        call dword ptr cs:[execip]
        pop cx
        jmp save0

; =============== Crypts by Alex Kislenko ===============
Kisl:	mov bx,ds:[1]
	add bx,3
        cmp word ptr ds:[bx],0c760h
        jnz retptr
        lea di,bx[10h]
	mov al,0c3h
        mov cx,50h
	repnz scasb
        or cx,cx
        jz retptr
	cmp dword ptr ds:[di],0e20fe380h
        jnz retptr
        cmp word ptr ds:[di+5],0ff61h
        jnz retptr
        push di bx
        @detect c24
        @class c24t
        pop bx di
	mov byte ptr ds:[di+6],0cbh	;retf
        mov ax,ds
        sub ax,10h
        mov ds,ax
	mov cs:[execcs],ax
        mov si,100h
        push bx
        xor bx,bx
        call dword ptr cs:[execip]
        pop cx
        jmp save0

; =============== SQRWV by Venus software ===============
SQRWV:	mov bx,0fh
	mov cx,1eh
        call chksum
        cmp ax,1270h
        jnz retptr
        @detect c25
        @class c25t
        mov cx,ds:[0dh]
        push cx
        mov bx,2dh
        add bx,cx
        shr cx,1
sqrw1:	dec bx
	dec bx
        mov ax,ds:[bx]
        xchg ch,cl
        rol ax,cl
        xor ax,cx
        xchg ch,cl
        not ax
        mov ds:[bx],ax
        loop sqrw1
        pop cx
        sub cx,22h
        mov bx,40h
        jmp save
; =============== Unknown crypt type 2 ===============
Unk2:	mov bx,ds:[1]
	add bx,3
        push bx
        add bx,1bh
        mov cx,1dh
        call chksum1
	pop bx
        cmp ax,0d27h
        jnz retptr
        push bx
        @detect c26
        @class c26t
        pop bx
        mov cx,ds:[bx+0fh]
        mov si,3h
        mov di,si
u2l1:	mov ah,0dh
	lodsb
        push offset u2l2
u2l3:	dec ah
	jz u2l4
        call u2l3
        ror al,1
        dec al
        xor al,cl
u2l4:	ret
u2l2:	stosb
	loop u2l1
	mov ax,ds:[bx+43h]
        mov ds:[0],ax
        mov al,ds:[bx+45h]
        mov ds:[2],al
savedi:	mov cx,di
        jmp save0	

; =============== Dismember 2.0 ===============
Dism2:	mov bx,ds:[1]
	add bx,3
        mov cx,18h
        call chksum1
        cmp ax,0f20h
        jnz retptr
        push bx
        @detect c27
        @class c27t
        pop bx
        lea cx,bx[-3]
        xor di,di
        mov si,3
        mov ah,cl
Dm21:	lodsb
	xor al,ah
        not al
        rol ah,1
        adc ah,cl
        stosb
        loop Dm21
        jmp savedi

; =============== HS 1.17cr for .com-files ===============
HS117c: mov bx,ds:[2]
	dec bh
        mov cx,69h
        call chksum
        cmp ax,3aadh
        jnz retptr
        @detect c28
        @class c28t
        mov ax,ds
        sub ax,10h
        mov ds,ax
        mov es,ax
        mov cx,ss
        push word ptr ds:[102h]
        mov cs:[oldss],cx
        mov cs:[oldsp],sp
        mov cs:[execcs],ax
        mov ss,ax
        xor sp,sp
	mov bx,ds:[102h]
        xor byte ptr ds:[bx+14fh],9eh
        xor byte ptr ds:[bx+8d5h],99h
	call dword ptr cs:[execip]
        mov ax,cs:[oldss]
        mov ss,ax
        mov sp,cs:[oldsp]
        pop bx
        mov cx,ds:[bx+89bh]
        sub cx,100h
        jmp save0

; =============== Com-packer by Digital Nightmare(?) ===============
Digc:	mov bx,130h
	mov cx,7ch
        call chksum
        cmp ax,3b91h
        jnz retptr
        cmp byte ptr ds:[0d7h],50h
        jnz retptr
        cmp byte ptr ds:[0e5h],0c3h
        jnz retptr
        @detect c29
        @class c29t
        mov ax,ds
        sub ax,10h
        mov ds,ax
        mov es,ax
	mov cs:[execcs],ax
        mov byte ptr ds:[1d7h],90h
        mov byte ptr ds:[1e5h],0cbh
	call dword ptr cs:[execip]
        lea cx,di[-100h]
	jmp save0

; =============== HS 1.17cr for .exe-files ===============
HS117e:	call chksum1
	mov ax,ds:[8]
        add ax,ds:[16h]
        shl ax,4
	add ax,ds:[14h]
        mov bx,ax
        mov cx,68h
        call chksum
	cmp ax,3214h
        jnz retptr
        push bx
        @detect c30
        @class c30t
        mov ax,ds:[8]
        mov cx,ds
        add ax,cx
        mov cx,ax
        add ax,ds:[16h]
        mov bx,ds:[14h]
        mov ds,ax
        mov fs,ax
        mov cs:[execcs],ax
        mov cs:[execip],bx
        inc byte ptr ds:[bx-0ch+2c0h]
        xor byte ptr ds:[bx-0ch+768h],47h xor 0eah
        xor byte ptr ds:[bx-0ch+638h],74h xor 0ebh
        mov ax,cs
        xor ax,0ff2bh
        xor word ptr ds:[bx-0ch+76bh],ax
        mov ax,offset HSec
        xor ax,0f9e2h
        xor word ptr ds:[bx-0ch+769h],ax
        push bx
        mov cs:[oldss],ss
        mov cs:[oldsp],sp
        mov ax,ds
	mov ss,ax
        mov sp,0fffeh
        sub cx,10h
        mov ds,cx
        mov es,cx
	jmp dword ptr cs:[execip]
HSec:	mov cx,ss
	mov dx,sp
        mov ax,cs:[oldss]
        mov ss,ax
        mov sp,cs:[oldsp]
	pop bx
        mov ax,cs:[inpsel]
        mov es,ax
        mov es:[10h],dx
	mov ax,fs:[bx-0ch+76eh]
        mov es:[14h],ax
        mov dx,ds
	mov ax,fs:[bx-0ch+770h]
	sub ax,dx
        sub ax,10h
        mov es:[16h],ax
        sub cx,10h
	sub cx,dx
        mov es:[0eh],cx
	pop cx
        mov di,cx
        jmp setlen1

; =============== Razor .com - checker ===============
Razcc:	mov bx,ds:[1]
	add bx,6
	mov cx,6eh-3
        call chksum1
        cmp ax,312bh
        jnz retptr
        @detect c31
        @class c31t
        mov bx,3
        mov cx,ds:[1]
        jmp save

; =============== Razor .com - packer ===============
Razcp:	cmp byte ptr ds:[0bh],0beh
	jnz retptr
        mov bx,ds:[0ch]
        sub bx,1c2h
        mov cx,0a1h
	call chksum1
        cmp ax,6a4ch
        jnz retptr
        mov byte ptr ds:[bx+94h],0cbh
	@detect c32
        @class c32t
        mov ax,ds
        sub ax,10h
        mov ds,ax
        mov es,ax
        mov cs:[execcs],ax
	call dword ptr cs:[execip]
	mov cx,di
        mov bx,100h
        sub cx,bx
        jmp save

        include dos.inc ; DOS Service pack routines
        end Start
